Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked.cpp	(revision 53)
@@ -0,0 +1,149 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+#ifdef SYSTEMC
+  RegisterFile_Multi_Banked::RegisterFile_Multi_Banked (sc_module_name name,
+#else
+  RegisterFile_Multi_Banked::RegisterFile_Multi_Banked (string name,
+#endif
+#ifdef STATISTICS
+			      morpheo::behavioural::Parameters_Statistics             param_statistics,
+#endif
+			      morpheo::behavioural::generic::registerfile::registerfile_multi_banked::Parameters param ):
+			      _name              (name)
+			      ,_param            (param)
+// #ifdef STATISTICS
+// 			      ,_param_statistics (param_statistics)
+// #endif
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"RegisterFile_Multi_Banked","Begin");
+
+#ifdef SYSTEMC
+    log_printf(INFO,RegisterFile_Multi_Banked,"RegisterFile_Multi_Banked","Allocation");
+
+    allocation ();
+#endif
+
+#ifdef STATISTICS
+    log_printf(INFO,RegisterFile_Multi_Banked,"RegisterFile_Multi_Banked","Allocation of statistics");
+
+    // Allocation of statistics
+    _stat = new Statistics (static_cast<string>(_name),
+			    param_statistics          ,
+			    param);
+#endif
+
+#ifdef VHDL
+    // generate the vhdl
+    log_printf(INFO,RegisterFile_Multi_Banked,"RegisterFile_Multi_Banked","Generate the vhdl");
+
+    vhdl();
+#endif
+
+#ifdef SYSTEMC
+    // Function pointer
+    if (_param._crossbar == FULL_CROSSBAR)                             
+      {
+	function_transition     = &morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::   full_crossbar_transition;
+	function_genMealy_read  = &morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::   full_crossbar_genMealy_read;
+	function_genMealy_write = &morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::   full_crossbar_genMealy_write;
+      }
+    else
+      {
+	function_transition     = &morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::   partial_crossbar_transition;
+	function_genMealy_read  = &morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::   partial_crossbar_genMealy_read;
+	function_genMealy_write = &morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::   partial_crossbar_genMealy_write;
+      }
+
+    log_printf(INFO,RegisterFile_Multi_Banked,"RegisterFile_Multi_Banked","Method - transition");
+
+    SC_METHOD (transition);
+    dont_initialize ();
+    sensitive_pos << *(in_CLOCK);
+
+#ifdef SYSTEMCASS_SPECIFIC
+    // List dependency information
+#endif    
+
+    log_printf(INFO,RegisterFile_Multi_Banked,"RegisterFile_Multi_Banked","Method - genMealy_write");
+
+    SC_METHOD (genMealy_read);
+    dont_initialize ();
+    sensitive_neg << *(in_CLOCK);
+    for (uint32_t i=0; i<_param._nb_port_read; i++)
+      sensitive << *( in_READ_VAL     [i])
+		<< *( in_READ_ADDRESS [i]);
+
+#ifdef SYSTEMCASS_SPECIFIC
+    // List dependency information
+    for (uint32_t i=0; i<_param._nb_port_read; i++)
+      {
+	(*(out_READ_ACK  [i])) (*( in_READ_VAL     [i]));
+	(*(out_READ_ACK  [i])) (*( in_READ_ADDRESS [i]));
+	(*(out_READ_DATA [i])) (*( in_READ_VAL     [i]));
+	(*(out_READ_DATA [i])) (*( in_READ_ADDRESS [i]));
+      }
+#endif    
+
+    SC_METHOD (genMealy_write);
+    dont_initialize ();
+    sensitive_neg << *(in_CLOCK);
+    for (uint32_t i=0; i<_param._nb_port_write; i++)
+      sensitive << *( in_WRITE_VAL     [i])
+		<< *( in_WRITE_ADDRESS [i])
+		<< *( in_WRITE_DATA    [i]);
+
+#ifdef SYSTEMCASS_SPECIFIC
+    // List dependency information
+    for (uint32_t i=0; i<_param._nb_port_write; i++)
+      {
+	(*(out_WRITE_ACK  [i])) (*( in_WRITE_VAL     [i]));
+	(*(out_WRITE_ACK  [i])) (*( in_WRITE_ADDRESS [i]));
+	(*(out_WRITE_ACK  [i])) (*( in_WRITE_DATA    [i]));
+      }
+#endif    
+
+#endif
+    log_printf(FUNC,RegisterFile_Multi_Banked,"RegisterFile_Multi_Banked","End");
+  };
+  
+  RegisterFile_Multi_Banked::~RegisterFile_Multi_Banked (void)
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"~RegisterFile_Multi_Banked","Begin");
+
+#ifdef STATISTICS
+    log_printf(INFO,RegisterFile_Multi_Banked,"~RegisterFile_Multi_Banked","Generate Statistics file");
+
+    _stat->generate_file(statistics(0));
+    
+    delete _stat;
+#endif
+
+#ifdef SYSTEMC
+    log_printf(INFO,RegisterFile_Multi_Banked,"~RegisterFile_Multi_Banked","Deallocation");
+
+    deallocation ();
+#endif
+
+    log_printf(FUNC,RegisterFile_Multi_Banked,"~RegisterFile_Multi_Banked","End");
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_address_xxx.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_address_xxx.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_address_xxx.cpp	(revision 53)
@@ -0,0 +1,47 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h"
+#include "Common/include/BitManipulation.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  Taddress_t RegisterFile_Multi_Banked::address_bank (Taddress_t address)
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"address_bank","Begin");
+    
+    Taddress_t _return = _param._bank_mask & (address >> _param._bank_shift);
+
+    log_printf(FUNC,RegisterFile_Multi_Banked,"address_bank","End");
+
+    return _return;
+  };
+
+  Taddress_t RegisterFile_Multi_Banked::address_num_reg (Taddress_t address)
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"address_num_reg","Begin");
+
+    Taddress_t _return = _param._num_reg_mask & (address >> _param._num_reg_shift);
+    
+    log_printf(FUNC,RegisterFile_Multi_Banked,"address_num_reg","End");
+
+    return _return;
+  };
+
+
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_allocation.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_allocation.cpp	(revision 53)
@@ -0,0 +1,129 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  void RegisterFile_Multi_Banked::allocation (void)
+  {
+    string rename;
+
+    log_printf(FUNC,RegisterFile_Multi_Banked,"allocation","Begin");
+
+    _component   = new Component ();
+
+    Entity * entity = _component->set_entity (_name       
+					      ,"RegisterFile_Multi_Banked"
+#ifdef POSITION
+					      ,Register 
+#endif
+					      );
+
+    _interfaces = entity->set_interfaces();
+
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+      Interface * interface = _interfaces->set_interface(""
+#ifdef POSITION
+							 ,IN
+							 ,SOUTH,
+							 "Generalist interface"
+#endif
+							 );
+
+     in_CLOCK        = interface->set_signal_clk              ("clock" ,1, CLOCK_VHDL_YES);
+     in_NRESET       = interface->set_signal_in  <Tcontrol_t> ("nreset",1, RESET_VHDL_YES);
+
+    // ~~~~~[ Interface : "read" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+     in_READ_VAL         = new SC_IN (Tcontrol_t) * [_param._nb_port_read];
+    out_READ_ACK         = new SC_OUT(Tcontrol_t) * [_param._nb_port_read];
+     in_READ_ADDRESS     = new SC_IN (Taddress_t) * [_param._nb_port_read];
+    out_READ_DATA        = new SC_OUT(Tdata_t   ) * [_param._nb_port_read];
+
+    for (uint32_t i=0; i<_param._nb_port_read; i++)
+      { 
+	Interface_fifo * interface = _interfaces->set_interface("read_"+toString(i)
+#ifdef POSITION
+								, IN  
+								,WEST
+								, "Interface Read"
+#endif
+								);
+
+	 in_READ_VAL     [i]  = interface->set_signal_valack_in        ("val"    , VAL);
+	out_READ_ACK     [i]  = interface->set_signal_valack_out       ("ack"    , ACK);
+	 in_READ_ADDRESS [i]  = interface->set_signal_in  <Taddress_t> ("address", static_cast<uint32_t>(log2(_param._nb_word)));
+	out_READ_DATA    [i]  = interface->set_signal_out <Tdata_t   > ("data"   , _param._size_word);
+      }
+
+    // ~~~~~[ Interface : "write" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+     in_WRITE_VAL        = new SC_IN (Tcontrol_t) * [_param._nb_port_write];
+    out_WRITE_ACK        = new SC_OUT(Tcontrol_t) * [_param._nb_port_write];
+     in_WRITE_ADDRESS    = new SC_IN (Taddress_t) * [_param._nb_port_write];
+     in_WRITE_DATA       = new SC_IN (Tdata_t   ) * [_param._nb_port_write];
+    
+    for (uint32_t i=0; i<_param._nb_port_write; i++)
+      {
+	Interface_fifo * interface = _interfaces->set_interface("write_"+toString(i)
+#ifdef POSITION
+								, IN  
+								,EAST
+								, "Interface Write"
+#endif
+								);
+
+	 in_WRITE_VAL     [i]  = interface->set_signal_valack_in        ("val"    , VAL);
+	out_WRITE_ACK     [i]  = interface->set_signal_valack_out       ("ack"    , ACK);
+	 in_WRITE_ADDRESS [i]  = interface->set_signal_in  <Taddress_t> ("address", static_cast<uint32_t>(log2(_param._nb_word)));
+	 in_WRITE_DATA    [i]  = interface->set_signal_in  <Tdata_t   > ("data"   , _param._size_word);
+      }
+
+    // ~~~~~[ Registers ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+    reg_DATA = new SC_REGISTER (Tdata_t) ** [_param._nb_bank];
+
+    for (uint32_t i=0; i<_param._nb_bank; i++)
+      {
+	reg_DATA [i] = new SC_REGISTER (Tdata_t) * [_param._nb_word];
+	
+	for (uint32_t j=0; j<_param._nb_word; j++)
+	  {
+	    string rename = "reg_DATA_"  + toString(i) + "_"  + toString(j);
+	    reg_DATA [i][j]  = new SC_REGISTER (Tdata_t) (rename.c_str());
+	  }
+      }
+
+    // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    internal_WRITE_VAL     = new bool       [_param._nb_port_write];
+    internal_WRITE_BANK    = new Taddress_t [_param._nb_port_write];
+    internal_WRITE_NUM_REG = new Taddress_t [_param._nb_port_write];
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+#ifdef POSITION
+    _component->generate_file();
+#endif
+
+    log_printf(FUNC,RegisterFile_Multi_Banked,"allocation","End");
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_deallocation.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_deallocation.cpp	(revision 53)
@@ -0,0 +1,58 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  void RegisterFile_Multi_Banked::deallocation (void)
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"deallocation","Begin");
+
+    delete in_CLOCK;
+    delete in_NRESET;
+
+    // ----- Interface Read
+    delete []  in_READ_VAL    ;
+    delete [] out_READ_ACK    ;
+    delete []  in_READ_ADDRESS;
+    delete [] out_READ_DATA   ;
+
+    // ----- Interface Write
+    delete []  in_WRITE_VAL    ;
+    delete [] out_WRITE_ACK    ;
+    delete []  in_WRITE_ADDRESS;
+    delete []  in_WRITE_DATA   ;
+
+    // ----- Register
+    delete [] reg_DATA;
+
+    // ----- Internal
+    delete [] internal_WRITE_VAL;
+    delete [] internal_WRITE_BANK;
+    delete [] internal_WRITE_NUM_REG;
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+    delete _component;
+
+    log_printf(FUNC,RegisterFile_Multi_Banked,"deallocation","End");
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_full_crossbar_genMealy_read.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_full_crossbar_genMealy_read.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_full_crossbar_genMealy_read.cpp	(revision 53)
@@ -0,0 +1,84 @@
+#ifdef SYSTEMC
+//#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  void RegisterFile_Multi_Banked::full_crossbar_genMealy_read (void)
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"full_crossbar_genMealy_read","Begin");
+
+    bool read_port_use [_param._nb_bank][_param._nb_port_read_by_bank];
+
+    for (uint32_t i=0; i<_param._nb_bank; i++)
+      for (uint32_t j=0; j<_param._nb_port_read_by_bank; j++)
+	read_port_use [i][j]=false;
+
+    for (uint32_t i=0; i<_param._nb_port_read; i++)
+      {
+	bool val = PORT_READ(in_READ_VAL    [i]);
+	bool ack = false;
+
+	log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_read","read[%d] : %d",i,val);
+
+	if (val == true)
+	  {
+	    // Compute the adress of the bank
+	    Taddress_t address = PORT_READ(in_READ_ADDRESS[i]);
+	    log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_read"," * address   : %d",address);
+	    Taddress_t bank    = address_bank    (address);
+	    log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_read"," * bank      : %d",bank   );
+
+	    // Search loop
+	    for (uint32_t j=0; j<_param._nb_port_read_by_bank; j++)
+	      {
+		// find a unbusy port on this bank
+		if (read_port_use[bank][j] == false)
+		  {
+		    // find !!!
+		    read_port_use[bank][j] = true;
+		    ack                    = true;
+		    
+		    Taddress_t num_reg = address_num_reg (address);
+
+		    log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_read"," * num_reg   : %d",num_reg);
+		    log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_read"," * bank_port : %d",j);
+
+		    Tdata_t    data    = REGISTER_READ(reg_DATA[bank][num_reg]);
+		    
+		    log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_read"," * data      : %d",data);
+
+		    PORT_WRITE(out_READ_DATA [i], data);
+
+		    break;
+		  }
+	      }
+	  }
+
+	// Write output
+	PORT_WRITE(out_READ_ACK [i], ack);
+      }
+
+    log_printf(FUNC,RegisterFile_Multi_Banked,"full_crossbar_genMealy_read","End");
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
+//#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_full_crossbar_genMealy_write.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_full_crossbar_genMealy_write.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_full_crossbar_genMealy_write.cpp	(revision 53)
@@ -0,0 +1,85 @@
+#ifdef SYSTEMC
+//#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  void RegisterFile_Multi_Banked::full_crossbar_genMealy_write (void)
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"full_crossbar_genMealy_write","Begin");
+
+    bool write_port_use [_param._nb_bank][_param._nb_port_write_by_bank];
+
+    for (uint32_t i=0; i<_param._nb_bank; i++)
+      for (uint32_t j=0; j<_param._nb_port_write_by_bank; j++)
+	write_port_use [i][j]=false;
+
+    for (uint32_t i=0; i<_param._nb_port_write; i++)
+      {
+	bool val = PORT_READ(in_WRITE_VAL    [i]);
+	bool ack = false;
+
+	log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_write","write[%d] : %d",i,val);
+
+	if (val == true)
+	  {
+	    val                = false;
+	    // Compute the adress of the bank
+	    Taddress_t address = PORT_READ(in_WRITE_ADDRESS[i]);
+	    log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_write"," * address   : %d",address);
+	    Taddress_t bank    = address_bank    (address);
+	    log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_write"," * bank      : %d",bank   );
+
+	    // Search loop
+	    for (uint32_t j=0; j<_param._nb_port_write_by_bank; j++)
+	      {
+		// find a unbusy port on this bank
+		if (write_port_use[bank][j] == false)
+		  {
+		    // find !!!
+		    write_port_use[bank][j] = true;
+		    val                     = true;  
+		    ack                     = true;
+		    
+		    Taddress_t num_reg = address_num_reg (address);
+
+		    log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_write"," * num_reg   : %d",num_reg);
+		    log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_write"," * bank_port : %d",j      );
+		    		    
+		    internal_WRITE_NUM_REG [i] = num_reg;
+		    break;
+		  }
+	      }
+
+	    internal_WRITE_BANK [i] = bank;
+	  }
+
+	internal_WRITE_VAL [i] = val;
+
+	// Write output
+	PORT_WRITE(out_WRITE_ACK [i], ack);
+      }
+
+    log_printf(FUNC,RegisterFile_Multi_Banked,"full_crossbar_genMealy_write","End");
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
+//#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_full_crossbar_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_full_crossbar_transition.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_full_crossbar_transition.cpp	(revision 53)
@@ -0,0 +1,33 @@
+#ifdef SYSTEMC
+//#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  void RegisterFile_Multi_Banked::full_crossbar_transition (void)
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"full_crossbar_transition","Begin");
+
+    log_printf(FUNC,RegisterFile_Multi_Banked,"full_crossbar_transition","End");
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
+//#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_genMealy_read.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_genMealy_read.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_genMealy_read.cpp	(revision 53)
@@ -0,0 +1,37 @@
+#ifdef SYSTEMC
+//#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  void RegisterFile_Multi_Banked::genMealy_read (void)
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"genMealy_read","Begin");
+
+    // call function pointer
+    (this->*function_genMealy_read) ();
+
+
+    log_printf(FUNC,RegisterFile_Multi_Banked,"genMealy_read","End");
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
+//#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_genMealy_write.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_genMealy_write.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_genMealy_write.cpp	(revision 53)
@@ -0,0 +1,36 @@
+#ifdef SYSTEMC
+//#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  void RegisterFile_Multi_Banked::genMealy_write (void)
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"genMealy_write","Begin");
+
+    // call function pointer
+    (this->*function_genMealy_write) ();
+
+    log_printf(FUNC,RegisterFile_Multi_Banked,"genMealy_write","End");
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
+//#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_partial_crossbar_genMealy_read.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_partial_crossbar_genMealy_read.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_partial_crossbar_genMealy_read.cpp	(revision 53)
@@ -0,0 +1,87 @@
+#ifdef SYSTEMC
+//#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  void RegisterFile_Multi_Banked::partial_crossbar_genMealy_read (void)
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"partial_crossbar_genMealy_read","Begin");
+
+    bool read_port_use [_param._nb_bank][_param._nb_port_read_by_bank];
+
+    for (uint32_t i=0; i<_param._nb_bank; i++)
+      for (uint32_t j=0; j<_param._nb_port_read_by_bank; j++)
+	read_port_use [i][j]=false;
+
+    for (uint32_t i=0; i<_param._nb_port_read; i++)
+      {
+	bool val = PORT_READ(in_READ_VAL    [i]);
+	bool ack = false;
+
+	log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_read","read[%d] : %d",i,val);
+
+	if (val == true)
+	  {
+	    // Compute the adress of the bank
+	    Taddress_t address = PORT_READ(in_READ_ADDRESS[i]);
+	    log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_read"," * address   : %d",address);
+	    Taddress_t bank    = address_bank    (address);
+	    log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_read"," * bank      : %d",bank   );
+
+// 	    // Search loop
+// 	    for (uint32_t j=0; j<_param._nb_port_read_by_bank; j++)
+// 	      {
+	    
+	    uint32_t j = _param._link_port_read_to_bank_read [i];
+
+		// find a unbusy port on this bank
+		if (read_port_use[bank][j] == false)
+		  {
+		    // find !!!
+		    read_port_use[bank][j] = true;
+		    ack                    = true;
+		    
+		    Taddress_t num_reg = address_num_reg (address);
+
+		    log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_read"," * num_reg   : %d",num_reg);
+		    log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_read"," * bank_port : %d",j);
+
+		    Tdata_t    data    = REGISTER_READ(reg_DATA[bank][num_reg]);
+		    
+		    log_printf(TRACE,RegisterFile_Multi_Banked,"full_crossbar_genMealy_read"," * data      : %d",data);
+
+		    PORT_WRITE(out_READ_DATA [i], data);
+
+// 		    break;
+		  }
+// 	      }
+	  }
+
+	// Write output
+	PORT_WRITE(out_READ_ACK [i], ack);
+      }
+
+    log_printf(FUNC,RegisterFile_Multi_Banked,"partial_crossbar_genMealy_read","End");
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
+//#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_partial_crossbar_genMealy_write.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_partial_crossbar_genMealy_write.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/RegisterFile_Multi_Banked_partial_crossbar_genMealy_write.cpp	(revision 53)
@@ -0,0 +1,87 @@
+#ifdef SYSTEMC
+//#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  void RegisterFile_Multi_Banked::partial_crossbar_genMealy_write (void)
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"partial_crossbar_genMealy_write","Begin");
+
+    bool write_port_use [_param._nb_bank][_param._nb_port_write_by_bank];
+    for (uint32_t i=0; i<_param._nb_bank; i++)
+      for (uint32_t j=0; j<_param._nb_port_write_by_bank; j++)
+	write_port_use [i][j]=false;
+
+    for (uint32_t i=0; i<_param._nb_port_write; i++)
+      {
+	bool val = PORT_READ(in_WRITE_VAL    [i]);
+	bool ack = false;
+
+	log_printf(TRACE,RegisterFile_Multi_Banked,"partial_crossbar_genMealy_write","write[%d] : %d",i,val);
+
+	if (val == true)
+	  {
+	    val                = false;
+	    // Compute the adress of the bank
+	    Taddress_t address = PORT_READ(in_WRITE_ADDRESS[i]);
+	    log_printf(TRACE,RegisterFile_Multi_Banked,"partial_crossbar_genMealy_write"," * address   : %d",address);
+	    Taddress_t bank    = address_bank    (address);
+	    log_printf(TRACE,RegisterFile_Multi_Banked,"partial_crossbar_genMealy_write"," * bank      : %d",bank   );
+
+// 	    // Search loop
+// 	    for (uint32_t j=0; j<_param._nb_port_write_by_bank; j++)
+// 	      {
+	    uint32_t j = _param._link_port_write_to_bank_write [i];
+
+		// find a unbusy port on this bank
+		if (write_port_use[bank][j] == false)
+		  {
+		    // find !!!
+		    write_port_use[bank][j] = true;
+		    val                     = true;  
+		    ack                     = true;
+		    
+		    Taddress_t num_reg = address_num_reg (address);
+
+		    log_printf(TRACE,RegisterFile_Multi_Banked,"partial_crossbar_genMealy_write"," * num_reg   : %d",num_reg);
+		    log_printf(TRACE,RegisterFile_Multi_Banked,"partial_crossbar_genMealy_write"," * bank_port : %d",j      );
+		    		    
+		    internal_WRITE_NUM_REG [i] = num_reg;
+
+// 		    break;
+		  }
+// 	      }
+
+	    internal_WRITE_BANK [i] = bank;
+	  }
+
+	internal_WRITE_VAL [i] = val;
+
+	// Write output
+	PORT_WRITE(out_WRITE_ACK [i], ack);
+      }
+
+    log_printf(FUNC,RegisterFile_Multi_Banked,"partial_crossbar_genMealy_write","End");
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
+//#endif
